# BALLOT.S                                            (c) 04.97 
# Beispiele fuer die SPIM-Prozedurkonvention
# Ballot-Zahlen
# Zur Verdeutlichung der Konvention seien die Register $a1 bis $a3
# nicht existent.
.data
input1: .asciiz "\nBallot (n,m)\nn=0: Ende \n\tn= "
input2: .asciiz "\tm= "
output: .asciiz "\nBallot (n,m) = "
.text
main:  
# Testumgebung fuer die Prozedur ballot
# Ruft ballot mit den vom Benutzer eingegebenen Werten 
# auf bis dieser mit n oder m = 0 beendet.
        li      $v0, 4          # Eingaben anfordern
        la      $a0, input1     
        syscall
        li      $v0, 5
        syscall
        beqz    $v0, exit
        move    $t0, $v0        # $t0 := n
        li      $v0, 4          
        la      $a0, input2
        syscall
        li      $v0, 5
        syscall
        beqz    $v0, exit
        sub     $sp, $sp, 4     # Prolog (1)    
                                # 1(a) Register sichern (hier: keine)
        sw      $v0, 4($sp)     # 1(b) Argumente uebergeben
        move    $a0, $t0        # 
        jal     ballot          # 1(c) Prozedurstart
                                # Epilog (4)
                                # 4(a) Register wiederherstellen (keins)
        add     $sp, $sp, 4     # 4(b) Stackpointer wiederherstellen
        move    $t0, $v0        # $t0:=ballot(n,m)
        li      $v0, 4          # Ergebnis ausgeben
        la      $a0, output     
        syscall
        li      $v0, 1
        move    $a0, $t0
        syscall
        j       main
exit:   li      $v0, 10        
        syscall
                                #
ballot: 
# Berechnet die Ballot-Zahl ballot (n,m)
# Argument 1 ($a0)  : n 
# Argument 2 (Stack): m => 4($fp)
# Ergebnis in $v0
# Registerbelegung innerhalb der Prozedur:
# $a0: n
# $s0: m (besser waere $t0, hier nur zur Demonstration!)
# $t0: Zwischenergebnis
                                # Prolog (2)
        sub     $sp, $sp, 12    # 2(a) Stackframe erstellen
        sw      $fp, 12($sp)    # 2(b) Register sichern
        sw      $ra, 8($sp)
        sw      $s0, 4($sp)
        addi    $fp, $sp, 12    # 2(c) Framepointer erstellen
        lw      $s0, 4($fp)     # m laden
                                # Ballot-Zahlen berechnen...
        beq     $a0, 1, min1    # IF n = 1 THEN ballot = -1
        beq     $s0, 1, plus1   # ELSIF m = 1 THEN ballot = 1
                                # ELSE ballot (n,m) = 
                                #   ballot (n, m-1) + 
                                #   ballot (n-1, m) END;
                                # Aufruf ballot (n, m-1)
                                # Prolog (1)
        sub     $sp, $sp, 12    # 1(a) Register sichern
        sw      $a0, 12($sp)    # $a0 sichern, $t0 noch nicht benutzt
        sw      $s0, 8($sp)     # Rueckrechnung waere einfacher!
        sub     $s0, $s0, 1     # 1(b) Arg. ueberg., $a0 ist bereits ok,
        sw      $s0, 4($sp)     # (m-1) muss berechnet werden
        jal     ballot          # 1(c) Prozedurstart
                                # Epilog (4)
        lw      $a0, 12($sp)    # 4(a) Register wiederherstellen
        lw      $s0, 8($sp)
        addi    $sp, $sp, 12    # 4(b) Stackpointer wiederherstellen
        move    $t0, $v0        # Ergebnis sichern
        sub     $a0, $a0, 1     # Aufruf ballot (n-1, m)
                                # Prolog (1)
        sub     $sp, $sp, 8     # 1(a) Register sichern
        sw      $t0, 8($sp)     # $t0 sichern, $a0 nicht mehr benutzt
        sw      $s0, 4($sp)     # 1(b) Arg. ueberg., $a0 ist bereits ok
        jal     ballot          # 1(c) Prozedurstart
                                # Epilog (4)
        lw      $t0, 8($sp)     # 4(a) Register wiederherstellen
        addi    $sp, $sp, 8     # 4(b) Stackpointer wiederherstellen
        add     $v0, $v0, $t0   # Funktionsergebnis berechnen
tollab:                         # Epilog (3)
                                # 3(a) Funktionswert (liegt in $v0)
        lw      $fp, 12($sp)    # 3(b) Register wiederherstellen
        lw      $ra,  8($sp)
        lw      $s0,  4($sp)
        addi    $sp, $sp, 12    # 3(c) Stackframe entfernen
        jr      $ra             # 3(d) Rcksprung
min1:   li      $v0, -1         # ballot = -1
        j       tollab
plus1:  li      $v0, 1          # ballot = 1
        j       tollab
