# HORNER.S                                                       (c) 06/97
# Implementation des Hornerschemas fuer Gleitkommazahlen doppelter
# Genauigkeit.
#
.data
Koeffs: .double 1.,     5.,     -2.     # ein Testfeld
last:   .double -24.
.text
#
# Hauptprogramm main
# Nach Eingabe des x-Wertes wird der Wert des Polynoms zwischen
# Koeffs und last an der Stelle x berechnet.
#
__start:
main:  la      $a0, Koeffs      # Initialisierung
       la      $a1, last
       li      $v0, 7           # Read_double
       syscall
       jal     poly
       li      $v0, 3           # Print_double
       syscall
       li      $v0, 10          # Exit
       syscall
# Funktion poly
# Berechnet den Wert eines Polynoms f an einer gegeben Stelle x
# Eingabe:
# $a0:    Adresse des hoechstrangigen Koeffizienten a_n des Polynoms.
#         Die Koeffizienten sind hintereinander mit sinkender Wertigkeit
#         als doppelt genaue Gleitkommazahlen abgelegt.
# $a1:    Adresse des niedrigstranigen Koeffizienten a_0 (Konstante)
# $f0/1:  Stelle x, an der das Polynom berechnet werden soll.
# $f12/13:Ergebnisakkumulation (akk)
# zusaetzlich verwendetes Register:
# $f10/11:temporaer a_n (tmp); wird gesichert!
.data
dbl0:   .double 0.
.text
poly:   addiu   $sp, $sp, -8    # Platz fuer $f10/11
        s.d     $f10, 8($sp)    # $f10/11 sichern
        l.d     $f12, dbl0      # Initialisierung, Windows-Version kann
                                # kein mtc1!
                                # besser waere: Zeile 35/36 loeschen,
                                # Zeile 40 ff:
                                # li      $t0, 0
                                # mtc1    $t0, $12
                                # cvt.d.w $f12, $f12
                                # oder einfach durch 
                                # sub.d $f12, $f12, $f12
        bgt     $a0, $a1, exit  # Fehler in der Adressierung
repeat: l.d     $f10, ($a0)     # tmp := a_n
        mul.d   $f12, $f12, $f0 # akk := akk * x
        add.d   $f12, $f12, $f10# akk := akk + a_n
        addiu   $a0, $a0, 8     # n := n + 1; 64-Bit-Zahlen!
        ble     $a0, $a1, repeat# solange nicht am Ende der Koeffizienten
exit:   l.d     $f10, 8($sp)    # $f10/11 wiederherstellen
        addiu   $sp, $sp, 8     # $sp wiederherstellen
        jr      $ra             # Bye-bye
